/* 
 *  libjcode.c -- ϊCu    1.0 
 *                (C) Kuramitsu Kimio, Tokyo Univ. 1996-97
 *
 *  ̃CúACGI Programming with C and Perl ̂߂
 *  Ken Lunde  u{񏈗v (O'llery) QlɂāA
 *  Xg[pjconv.c AXgOΉɂăCu
 *  ܂B 
 *  ACGI (INTERNET)ł̗plāAύXĂ܂B
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <the.h>
#include <jlib.h>
/*
 * config.h
 */

#define NEW           4
#define OLD           5
#define NEC           6
#define EUCORSJIS     7
#define NUL           0
#define LF            10
#define FF            12
#define CR            13
#define ESC           27
#define SS2           142

/* pJi(SJIS) IɑSpJiɕύX */

#define NO_HANKAKU_SJIS

/* Ђ炪ȁAJ^Ji̕т EUC , SJIS 𐄒肷 */

#define KANA_NARABI

/* fobNp̊֐Lɂ */

#define DEBUG

 
#define CHAROUT(ch) *str2 = (unsigned char)(ch); str2++;

/* --------------------------------------- JIS(ISO-2022) R[h֐؂ւ -- */

unsigned char *_to_jis(unsigned char *str) {
  *str = (unsigned char)ESC; str++;
  *str = (unsigned char)'$'; str++;
  *str = (unsigned char)'B'; str++;
  return str;
}

/* ----------------------------------------------- ASCII R[h֐؂ւ -- */

/* ESC ( B  ESC ( J ̈ႢB
   {́A ESC ( J JIS-Roman ̌nł邪A
   C^[lbg̏ł́ApASCII ̕RƎvB
   \ L ~LႤłB */

unsigned char *_to_ascii(unsigned char *str) {
  *str = (unsigned char)ESC; str++;
  *str = (unsigned char)'('; str++;
  *str = (unsigned char)'B'; str++;
  return str;
}

/* -------------------------------------- JIS R[h  SJISƂăVtg -- */

void _jis_shift(int *p1, int *p2)
{
  unsigned char c1 = *p1;
  unsigned char c2 = *p2;
  int rowOffset = c1 < 95 ? 112 : 176;
  int cellOffset = c1 % 2 ? (c2 > 95 ? 32 : 31) : 126;

  *p1 = ((c1 + 1) >> 1) + rowOffset;
  *p2 += cellOffset;
}

/* --------------------------------- SJIS R[hJIS R[hƂăVtg -- */

void _sjis_shift(int *p1, int *p2)
{
  unsigned char c1 = *p1;
  unsigned char c2 = *p2;
  int adjust = c2 < 159;
  int rowOffset = c1 < 160 ? 112 : 176;
  int cellOffset = adjust ? (c2 > 127 ? 32 : 31) : 126;

  *p1 = ((c1 - rowOffset) << 1) - adjust;
  *p2 -= cellOffset;
}

/* ---------------------------------------------- SJIS pSpɕϊ -- */
/* Noda THE3.0J 2000/01/13  Delete
#define HANKATA(a)  (a >= 161 && a <= 223)
* Noda THE3.0J 2000/01/13  Delete */

/* Noda THE3.0J 2000/01/13  Start */
#define HANKATA(a)  (file_kana2 != 0 && a >= 161 && a <= 223)
/* Noda THE3.0J 2000/01/13  End */

#define ISMARU(a)   (a >= 202 && a <= 206)
#define ISNIGORI(a) ((a >= 182 && a <= 196) || (a >= 202 && a <= 206) || (a == 179))

static int stable[][2] = {
    {129,66},{129,117},{129,118},{129,65},{129,69},{131,146},{131,64},
    {131,66},{131,68},{131,70},{131,72},{131,131},{131,133},{131,135},
    {131,98},{129,91},{131,65},{131,67},{131,69},{131,71},{131,73},
    {131,74},{131,76},{131,78},{131,80},{131,82},{131,84},{131,86},
    {131,88},{131,90},{131,92},{131,94},{131,96},{131,99},{131,101},
    {131,103},{131,105},{131,106},{131,107},{131,108},{131,109},
    {131,110},{131,113},{131,116},{131,119},{131,122},{131,125},
    {131,126},{131,128},{131,129},{131,130},{131,132},{131,134},
    {131,136},{131,137},{131,138},{131,139},{131,140},{131,141},
    {131,143},{131,147},{129,74},{129,75}};

unsigned char *_sjis_han2zen(unsigned char *str, int *p1, int *p2)
{
  register int c1, c2;

  c1 = (int)*str; str++;
  *p1 = stable[c1 - 161][0];
  *p2 = stable[c1 - 161][1];

  /* Ȁ */
  c2 = (int)*str;
  if (c2 == 222 && ISNIGORI(c1)) {
    if ((*p2 >= 74 && *p2 <= 103) || (*p2 >= 110 && *p2 <= 122))
      (*p2)++;
    else if (*p1 == 131 && *p2 == 69)
      *p2 = 148;
    str++;
  }

  if (c2 == 223 && ISMARU(c1) && (*p2 >= 110 && *p2 <= 122) ) {
    *p2 += 2;
    str++;
  }
  return str++;
}

/* -------------------------------------------------- SJIS R[hϊ -- */

#define SJIS1(A)    ((A >= 129 && A <= 159) || (A >= 224 && A <= 239))
#define SJIS2(A)    (A >= 64 && A <= 252)

void _shift2seven(unsigned char *str, unsigned char *str2)
{
  int p1,p2,esc_in = FALSE;

  while ((p1 = (int)*str) != '\0') {

    if (SJIS1(p1)) {
      if((p2 = (int)*(++str)) == '\0') break;
      if (SJIS2(p2)) {
        _sjis_shift(&p1,&p2);
        if (!esc_in) {
          esc_in = TRUE;
          str2 = _to_jis(str2);
        }
      }
      CHAROUT(p1);
      CHAROUT(p2);
      str++;
      continue;
    }

#ifdef NO_HANKAKU_SJIS
    /* p SJIS ́AIɑSpɕς */
    if (HANKATA(p1)) {
      str = _sjis_han2zen(str, &p1, &p2);
      _sjis_shift(&p1,&p2);
      if (!esc_in) {
        esc_in = TRUE;
        str2 = _to_jis(str2);
      }
      CHAROUT(p1);
      CHAROUT(p2);
      continue;
    }
#endif

    if (esc_in) {
      /* LF / CR ̏ꍇ́AɃGXP[vAEg */
      esc_in = FALSE;
      str2 = _to_ascii(str2);
    }
    CHAROUT(p1);
    str++;
  }

  if (esc_in)
    str2 = _to_ascii(str2);
  *str2='\0';
}

/* --------------------------------------------- SJIS  EUC ɕϊ -- */

void _shift2euc(unsigned char *str, unsigned char *str2)
{
  int p1,p2;
  
  while ((p1 = (int)*str) != '\0') {
    if (SJIS1(p1)) {
      if((p2 = (int)*(++str)) == '\0') break;
      if (SJIS2(p2)) {
        _sjis_shift(&p1,&p2);
        p1 += 128;
        p2 += 128;
      }
      CHAROUT(p1);
      CHAROUT(p2);
      str++;
      continue;
    }

#ifdef NO_HANKAKU_SJIS
    /* p SJIS ́AIɑSpɕς */
    if (HANKATA(p1)) {
      str = _sjis_han2zen(str,&p1,&p2);
      _sjis_shift(&p1,&p2);
      p1 += 128;
      p2 += 128;
      CHAROUT(p1);
      CHAROUT(p2);
      continue;
    }
#endif
    CHAROUT(p1);
    str++;
  }
  *str2='\0';
}

/* ------------------------------------------------- p SJIS 菜 -- */

void _shift_self(unsigned char *str, unsigned char *str2)
{
  int p1,p2;
  
  while ((p1 = (int)*str) != '\0') {
#ifdef NO_HANKAKU_SJIS
    /* p SJIS ́AIɑSpɕς */
    if (HANKATA(p1)) {
      str = _sjis_han2zen(str, &p1, &p2);
      CHAROUT(p1);
      CHAROUT(p2);
      continue;
    }
#endif
    CHAROUT(p1);
    str++;
  }
  *str2='\0';
}

/* ------------------------------------------------------EUC  JIS  -- */

#define ISEUC(A)    (A >= 161 && A <= 254)

void _euc2seven(unsigned char *str, unsigned char *str2)
{
  int p1, p2, esc_in = FALSE;

  while ((p1 = (int)*str) != '\0') {

    if (p1 == LF || p1 == CR) {
      if (esc_in) {
        esc_in = FALSE;
        str2 = _to_ascii(str2);
      }
      CHAROUT(p1);
      str++;
      continue;
    }

    if (ISEUC(p1)) {
      if((p2 = (int)*(++str)) == '\0') break;
      if (ISEUC(p2)) {

	if (!esc_in) {
	  esc_in = TRUE;
	  str2 =_to_jis(str2);
	}

	CHAROUT(p1-128);
	CHAROUT(p2-128);
	str++;
	continue;
      }
    }

    if (esc_in) {
      esc_in = FALSE;
      str2 = _to_ascii(str2);
    }
    CHAROUT(p1);
    str++;
  }
  *str2='\0';
}

/* ------------------------------------------------ EUC  SJIS ɕϊ -- */
 
void _euc2shift(unsigned char *str, unsigned char *str2)
{
  int p1,p2;

  while ((p1 = (int)*str) != '\0') {
    if (ISEUC(p1)) {
      if((p2 = (int)*(++str)) == '\0') break;
      if (ISEUC(p2)) {
	p1 -= 128;
        p2 -= 128;
        _jis_shift(&p1,&p2);
      }
      CHAROUT(p1);
      CHAROUT(p2);
      str++;
      continue;
    }

    CHAROUT(p1);
    str++;
  }
  *str2='\0';
}

/* -------------------------------------- ESC V[PXXLbv ----- */

unsigned char *_skip_esc(unsigned char *str, int *esc_in) {
  int c;
  
  c = (int)*(++str);
  if ((c == '$') || (c == '(')) str++;
  if ((c == 'K') || (c == '$')) *esc_in = TRUE;
  else *esc_in = FALSE;

  if(*str != '\0') str++;
  return str;
}


/* ----------------------------------------------- JIS  SJIS ɕϊ -- */

void _seven2shift(unsigned char *str, unsigned char *str2)
{
  int p1, p2, esc_in = FALSE;

  while ((p1 = (int)*str) != '\0') {

    /* ESCV[PXXLbv */
    if (p1 == ESC) {
      str = _skip_esc(str, &esc_in);
      continue;
    }

    if (p1 == LF || p1 == CR) {
      if (esc_in) esc_in = FALSE;
    }

    if(esc_in) { /* ISO-2022-JP R[h */
      if((p2 = (int)*(++str)) == '\0') break;

      _jis_shift(&p1, &p2);

      CHAROUT(p1);
      CHAROUT(p2);
    }else{       /* ASCII R[h */
      CHAROUT(p1);
    }
    str++;
  }
  *str2 = '\0';
}

/* ------------------------------------------------ JIS  EUC ɕϊ -- */

void _seven2euc(unsigned char *str, unsigned char *str2)
{
  int p1, esc_in = FALSE;

  while ((p1 = (int)*str) != '\0') {

    /* ESCV[PXXLbv */
    if (p1 == ESC) {
      str = _skip_esc(str, &esc_in);
      continue;
    }

    if (p1 == LF || p1 == CR) {
      if (esc_in) esc_in = FALSE;
    }

    if(esc_in) { /* ISO-2022-JP R[h */
      CHAROUT(p1 + 128); 
      
      if((p1 = (int)*(++str)) == '\0') break;
      CHAROUT(p1 + 128);
    }else{       /* ASCII R[h */
      CHAROUT(p1);
    }
    str++;
  }
  *str2 = '\0';
}

/* ------------------------------------------------------------------------ */
/* --------------------------------------------------------- Public ֐ -- */

/*#define STATIC_BUFFER BUFSIZ*/

unsigned char *_set_buffer(char *str) {
#ifdef STATIC_BUFFER
  static unsigned char buf[STATIC_BUFFER];
#else
  static unsigned char *buf;

  if((buf = (unsigned char *)(*the_malloc)((strlen(str) + 1) * 3)) == NULL) {
    fprintf(stderr, "Can't malloc buffer\n");
    exit(2);
  }
#endif
  return buf;
}

char *_replace_buffer(unsigned char *buf) {
  unsigned char *p;
  char *str;

  if((str = (char *)(*the_malloc)(strlen(buf) + 1)) == NULL) {
    fprintf(stderr, "Can't malloc string buffer\n");
    exit(2);
  }

  p = (unsigned char *)str;
   
  while(*buf) {
    *p = *buf; buf++; p++;
  }
  *p = '\0';
#ifndef STATIC_BUFFER
  (*the_free)(buf);
#endif
  return str;
}

char *toStringJIS(char *str) {
  int detected;
  unsigned char *buf;

  detected = detectKanjiCode(str);

  if(detected == ASCII || detected == JIS)
    return str;

  buf = _set_buffer(str);

  switch(detected) {
  case SJIS :
    _shift2seven((unsigned char *)str, buf);
    break;
  case EUC :
    _euc2seven((unsigned char *)str, buf);
    break;
  default:
    (*the_free)(buf);
    return str;
    break;
  }
  return buf;
/*
  return (char *)_replace_buffer(buf);
*/
}

char *toStringEUC(char *str) {
  int detected;
  unsigned char *buf;

  detected = detectKanjiCode(str);

  if(detected == ASCII) return str;

  buf = _set_buffer(str);

  switch(detected) {
  case SJIS :
    _shift2euc((unsigned char *)str, buf);
    break;
  case JIS :
  case NEW : case OLD : case NEC :
     _seven2euc((unsigned char *)str, buf);
    break;
  default:
    (*the_free)(buf);
    return str;
    break;
  }

  return buf;
/*
  return (char *)_replace_buffer(buf);
*/
}

char *toStringSJIS(char *str) {
  int detected;
  unsigned char *buf;

  detected = detectKanjiCode(str);
  if(detected == ASCII) return str;
  
  buf = _set_buffer(str);

  switch(detected) {
  case NEW : case OLD : case NEC :
  case JIS :
    _seven2shift((unsigned char *)str, buf);
    break;
  case EUC :
    _euc2shift((unsigned char *)str, buf);
    break;
  case SJIS :  
  default:
    _shift_self((unsigned char *)str, buf);
  }

  return buf;
/*
  return _replace_buffer(buf);
*/
}


char *test(char *str) {
  static char buffer[BUFSIZ];
  
  _shift2seven((unsigned char *)str, (unsigned char *)buffer);
  
  return (char *)buffer;
}




/*
 * detect.c - libjcode R[h胋[`
 *                (C) Kuramitsu Kimio, Tokyo Univ. 1996-97 
 *
 * Ken Lunde  u{񏈗v  jconv.c Qlɍ 
 * ܂B
 * CGI vOł̗plāAЂ炪ȁAȂ̕
 * ɂSJIS, EUC ̐ASYĂ܂B
 *
 */


/* ------------------------------------------------------ R[h̎ --*/

int _detect(unsigned char *str, int expected)
{
  register int c;

  while((c = (int)*str)!= '\0') {

    /* JIS R[h̔ */
    if(c == ESC) {
      if((c = (int)*(++str)) == '\0') return expected; 
      if (c == '$') {
	if((c = (int)*(++str)) == '\0') return expected; 
	/* ESC $ B --> VJIS 
	   ESC $ @ --> JIS */
	if (c == 'B' || c == '@') return JIS;
      }
#ifdef NECKANJI
      if (c == 'K')
	return NEC;    /* ESC K --> NEC JIS */
#endif
      str++;
      continue;
    }
    
    /* SJIS ɈӂɌ */
    if ((c >= 129 && c <= 141) || (c >= 143 && c <= 159))
        return SJIS;
    /* SS2 */
    if (c == SS2) {
      if((c = (int)*(++str)) == '\0') return expected; 
      if ((c >= 64 && c <= 126) || (c >= 128 && c <= 160) || 
	  (c >= 224 && c <= 252)) return SJIS;
      if (c >= 161 && c <= 223) expected = EUCORSJIS;
      str++;
      continue;
    }

    if (c >= 161 && c <= 223) {
      if((c = (int)*(++str)) == '\0') return expected; 
      
      if (c >= 240 && c <= 254)
	return EUC;
      if (c >= 161 && c <= 223) {
	expected = EUCORSJIS;
	str++;
	continue;
      }
      if (c <= 159) return SJIS;
      if (c >= 240 && c <= 254) return EUC;
     
      if (c >= 224 && c <= 239) {
	expected = EUCORSJIS;
	while (c >= 64) {
	  if (c >= 129) {
	    if (c <= 141 || (c >= 143 && c <= 159))
	      return SJIS;
	    else if (c >= 253 && c <= 254) {
	      return EUC;
	    }
	  }
	  if((c = (int)*(++str)) == '\0') return EUCORSJIS; 
	}
	str++;
	continue;
      }
      
      if (c >= 224 && c <= 239) {
        if((c = (int)*(++str)) == '\0') return expected; 
        if ((c >= 64 && c <= 126) || (c >= 128 && c <= 160))
          return SJIS;
        if (c >= 253 && c <= 254) return EUC;
        if (c >= 161 && c <= 252)
          expected = EUCORSJIS;
      }
    }
    str++;
  }
  return expected;
}

/* ---------------------------------------------------SJIS  EUC ̔ -- */
/* {̓(Ђ炪ȁAJ^Ji)画肷邽߁A
   ~Xꍇ܂B */

int _detect_euc_or_sjis(unsigned char *str) {
  int c1, c2 = -1;
  int expected = EUCORSJIS; /* ftHgSJIS */

  while((c1 = (int)*str) != '\0') {
    if(c1 == 0xa4 || c1 == 0xa5) {
      str++;
      if(*str == '\0') break; else str++;
      if((c2 = (int)*str) == '\0') break;
      if(c2 == 0xa4 || c2 == 0xa5) {
	expected = EUC;
	return EUC;
      }
    }
    str++;
  }
  return expected;
}

int _cache_euc_or_sjis(int code)
{
  static int cache = SJIS;     /* ftHǵASJIS */
  if(code == EUC || code == SJIS ) cache = code;
  if(code == EUCORSJIS) return cache; else return code;
}

/* ---------------------------------------------------------- Public ֐ -- */


#ifdef DEBUG
void printDetectCode(int detected) {
  switch(detected) {
  case ASCII:
    printf("ASCII/JIS-Roman characters(94 printable)\n");
    break;
  case JIS:
    printf("JIS(iso-2022-jp)\n");
    break;
  case EUC:
    printf("EUC(x-euc-jp)\n");
    break;
  case SJIS:
    printf("SJIS(x-sjis)\n");
    break;
  case NEW:
    printf("JIS X 0208-1990\n");
    break;
  case OLD:
    printf("JIS X 0208-1978\n");
    break;
  case EUCORSJIS:
    printf("EUC or SJIS\n");
    break;
  default:
    printf("Another Codes!!\n");
  }
}
#endif

int detectKanjiCode(char *str)
{
  static int detected = ASCII;

  /* JIS, EUC, SJIS, EUCORSJIS ̔ */
  detected = _detect((unsigned char *)str, ASCII);

  /* VJIS, JIS, NEC JIS ̏ꍇAJIS ɕύX */
  if(detected == NEW || detected == OLD || detected == NEC)
    return JIS;

#ifndef NO_NARABI_CHECK
  /* SJIS  EUC ̋ʂJi̕т琄肷 */
  if(detected == EUCORSJIS)
    detected = _detect_euc_or_sjis((unsigned char *)str);
#endif

  /* SJIS  EUC ̔ɋO̔ɏ] */
  detected = _cache_euc_or_sjis(detected);

  return detected;
}
